# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing
import typing_extensions
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class KnowledgeBase(UniversalBaseModel):
    name: str = pydantic.Field()
    """
    The name of the knowledge base
    """

    provider: typing.Literal["google"] = pydantic.Field(default="google")
    """
    The provider of the knowledge base
    """

    model: typing.Dict[str, typing.Optional[typing.Any]] = pydantic.Field()
    """
    The model to use for the knowledge base
    """

    description: str = pydantic.Field()
    """
    A description of the knowledge base
    """

    file_ids: typing_extensions.Annotated[typing.List[str], FieldMetadata(alias="fileIds")] = pydantic.Field()
    """
    The file IDs associated with this knowledge base
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
